<?php
if (!defined('IN_AJAX')) die(basename(__FILE__));

global $bb_cfg, $lang, $userdata, $user;

if (!isset($this->request['mode']))
{
	$this->ajax_die($lang['SELECT_A_MODE']);
}

$mode = (string) $this->request['mode'];
$message = '';

switch ($mode)
{
	case 'update':
        $trash_forums = ($bb_cfg['trash_forum_id']) ? $bb_cfg['trash_forum_id'] : '0';
        $ignor_forum = $bb_cfg['new_add_post_num']['ignor'];
	    $limit = $bb_cfg['new_add_post_num'];
	    $sql = DB()->fetch_rowset("
					SELECT 
						p.topic_id, p.forum_id, p.poster_id, p.post_id, p.post_time,
						t.topic_id, t.topic_title, t.forum_id, t.topic_last_post_time, f.*, u.user_id, u.username, u.user_avatar, u.user_avatar_type, u.user_opt, u.user_rank
					FROM ". BB_TOPICS ." AS t, ". BB_POSTS ." AS p, ". BB_USERS ." AS u, ". BB_FORUMS . " AS f
					WHERE p.forum_id = p.forum_id
						AND f.auth_read = ". AUTH_ALL ."
						AND p.forum_id NOT IN($ignor_forum, f.allow_porno_topic, $trash_forums)
						AND p.post_id = p.post_id
						AND p.poster_id = u.user_id
						AND p.forum_id = f.forum_id
						AND p.poster_id = u.user_id
						AND t.topic_id = p.topic_id
						AND u.username = u.username
					GROUP BY p.post_time DESC
					LIMIT 0,".$bb_cfg['new_add_post_num']['num']
				);
		CACHE('bb_cache')->set('last_post', $sql, $bb_cfg['new_add_post_num']['cache']*60);
		foreach ($sql as $row)
		{
			$user_avatar = '';
			if ( !$user->opt_js['h_av'] && $row['user_id'] != ANONYMOUS )
			{
				$user_avatar = get_avatar($row['user_avatar'], $row['user_avatar_type'], !bf($row['user_opt'], 'user_opt', 'allow_avatar'), '32', '32');
			}
            $user_avatars       = $user_avatar;
			$topic_title        = addslashes(str_short($row['topic_title'], $bb_cfg['title_lp_stext']));
			$post_id            = $row['post_id'];
			$topic_id           = $row['topic_id'];
			$forum              = $row['forum_name'];
			$forum_id           = $row['forum_id'];
			$autor_post         = profile_url(array('username' => $row['username'], 'user_id' => $row['user_id'], 'user_rank' => $row['user_rank']));
			$autor_post_id      = $row['user_id'];
			$post_time          = bb_date($row['post_time']);
			$url_new_post       = make_url(POST_URL . $row['post_id'], $row['topic_title'],true);
			$url_forum          = make_url(FORUM_URL . $row['forum_id'], $row['forum_name'],true);
            $message .= '<tr rel="viewpost.php?id='.$post_id .'" class="jsTip" jtip="true" name="'.$topic_title.'" id="post_'.$post_id .'">';
            $message .= ($bb_cfg['ava_lp_on']) ? '<td style="border-bottom: 1px solid #C3CBD1;">'.$user_avatars.'</td>' : '';
            $message .= '<td class="f_titles" style="border-bottom: 1px solid #C3CBD1;">';
            $message .= '<div><a href="'.$url_new_post.'" style="font-size:11px">'.$topic_title.'</a></div>';
            $message .= '<div style="font-size:10px;"><a href="'.make_url('profile.php?mode=viewprofile&u='.$autor_post_id).'">'.$autor_post.'</a>';
			$message .= ($bb_cfg['data_lp_on']) ? ' '.$post_time. '' : ''; 
			$message .= ' <a href="'.$url_new_post.''.$row['post_id'].'#'.$row['post_id'].'">>></a></div>';
			$message .= ($bb_cfg['forum_lp_on']) ? '<div style="font-size:10px">'.$lang['FORUM'].': <a href="'.$url_forum.'">'.$forum.'</a></div>' : '';
            $message .= '</td></tr>';
		}
		$message .= '<tr><td align="left">';
		$message .= '<td align="right"><a title="Следующие '.$bb_cfg['new_add_post_num']['num'].' тем" href="#" onclick="ajax.exec({action : \'last_post\', mode: \'new_post\', type: 1}); return false;">>>></a></td>';
		$message .= '</tr>';
		$this->response['message']     = $message;
	break;
	
	case 'new_post':	
        $type = (int) $this->request['type'];
        $limit = $type * 5;
        $trash_forums = $bb_cfg['trash_forum_id'] ? $bb_cfg['trash_forum_id'] : '0';
        $ignor_forum = $bb_cfg['new_add_post_num']['ignor'];
	    $sql = DB()->fetch_rowset("
					SELECT 
						p.topic_id, p.forum_id, p.poster_id, p.post_id, p.post_time,
						t.topic_id, t.topic_title, t.forum_id, t.topic_last_post_time, f.*, u.user_id, u.username, u.user_avatar, u.user_avatar_type, u.user_opt, u.user_rank
					FROM ". BB_TOPICS ." AS t, ". BB_POSTS ." AS p, ". BB_USERS ." AS u, ". BB_FORUMS . " AS f
					WHERE p.forum_id = p.forum_id
						AND f.auth_read = ". AUTH_ALL ."
						AND p.forum_id NOT IN($ignor_forum, f.allow_porno_topic, $trash_forums)
						AND p.post_id = p.post_id
						AND p.poster_id = u.user_id
						AND p.forum_id = f.forum_id
						AND p.poster_id = u.user_id
						AND t.topic_id = p.topic_id
						AND u.username = u.username
					GROUP BY p.post_time DESC
					LIMIT $limit,".$bb_cfg['new_add_post_num']['num']
				);
		foreach ($sql as $row)
		{
			$user_avatar = '';
			if ( !$user->opt_js['h_av'] && $row['user_id'] != ANONYMOUS )
			{
				$user_avatar = get_avatar($row['user_avatar'], $row['user_avatar_type'], !bf($row['user_opt'], 'user_opt', 'allow_avatar'), '32', '32');
			}
			$user_avatars       = $user_avatar;
			$topic_title        = addslashes(str_short($row['topic_title'], $bb_cfg['title_lp_stext']));
			$post_id            = $row['post_id'];
			$topic_id           = $row['topic_id'];
			$forum              = $row['forum_name'];
			$forum_id           = $row['forum_id'];
			$autor_post         = profile_url(array('username' => $row['username'], 'user_id' => $row['user_id'], 'user_rank' => $row['user_rank']));
			$autor_post_id      = $row['user_id'];
			$post_time          = bb_date($row['post_time']);
			$url_new_post       = seo_url(POST_URL . $row['post_id'], $row['topic_title']);
			$url_forum          = seo_url(FORUM_URL . $row['forum_id'], $row['forum_name']);
			$message .= '<tr rel="viewpost.php?id='.$post_id .'" class="jsTip" jtip="true" name="'.$topic_title.'" id="post_'.$post_id .'">';
			$message .= ($bb_cfg['ava_lp_on']) ? '<td style="border-bottom: 1px solid #C3CBD1;">'.$user_avatars.'</td>' : '';
			$message .= '<td class="f_titles" style="border-bottom: 1px solid #C3CBD1;">';
			$message .= '<div><a href="'.$url_new_post.'" style="font-size:11px">'.$topic_title.'</a></div>';
			$message .= '<div style="font-size:10px;"><a href="profile.php?mode=viewprofile&u='.$autor_post_id.'">'.$autor_post.'</a>';
			$message .= ($bb_cfg['data_lp_on']) ? ' '.$post_time. '' : ''; 
			$message .= ' <a href="'.$url_new_post.''.$row['post_id'].'#'.$row['post_id'].'">>></a></div>';
			$message .= ($bb_cfg['forum_lp_on']) ? '<div style="font-size:10px">'.$lang['FORUM'].': <a href="'.$url_forum.'">'.$forum.'</a></div>' : '';
			$message .= '</td></tr>';
		}
		$message .= '<tr><td align="left">';
		$message .= ($type) ? '<a title="Предыдущие '.$bb_cfg['new_add_post_num']['num'].' тем" href="#" onclick="ajax.exec({action : \'last_post\', mode: \'new_post\', type: '. ($type - 1) .'}); return false;"><<<</a>' : '';
		$message .= '</td><td align="right"><a title="Следующие '.$bb_cfg['new_add_post_num']['num'].' тем" href="#" onclick="ajax.exec({action : \'last_post\', mode: \'new_post\', type: '. ($type + 1) .'}); return false;">>>></a></td>';
		$message .= '</tr>';
		$this->response['message']     = $message;
	break;
	
	default:
		$this->ajax_die($lang['SELECT_A_MODE']);
	break;
}
$this->response['mode']     = $mode;
